import React, { Component } from 'react';
import Base from '@icode-run/component-layout/utils/Base';
import Enum from '@icode-run/enum-input/src/Enum';

export default class MyComponent extends Base {
  state = {
    enumOptions: []
  }

  static getDerivedStateFromProps({
    enumOptionsParam
  }, prevState) {
    const options = {};
    if(enumOptionsParam) {
      options.enumOptions = enumOptionsParam.value || [];
    }
    return options;
  }

  componentDidMount() {

  }

  onChangeEnumOptions = (options) => {
    const {enumOptionsParam = {}} = this.props;
    if(enumOptionsParam.onChange && typeof enumOptionsParam.onChange === 'function') {
      enumOptionsParam.onChange(options);
    }
  }

  render() {
    const {
      className, 
      style,
      ableRemove, 
      ableMove, 
      ableAdd, 
      size = 'middle', 
      optionsEmpty,
    } = this.props;
    const {enumOptions = []} = this.state;
    return <div className={className || ''} style={style || {}}>
      <Enum
      ableRemove={ableRemove}
      ableMove={ableMove}
      ableAdd={ableAdd}
      ableChecked={false}
      multiple={false}
      size={size}
      enumOptions={enumOptions}
      optionsEmpty={optionsEmpty}
      onChange={(enumOptions) => {
        this.onChangeEnumOptions(enumOptions);
      }}
    />
    </div>;
  }
};
